# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ScheduleArgs', 'Schedule']

@pulumi.input_type
class ScheduleArgs:
    def __init__(__self__, *,
                 branch: pulumi.Input[str],
                 cronline: pulumi.Input[str],
                 label: pulumi.Input[str],
                 pipeline_id: pulumi.Input[str],
                 commit: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 env: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 message: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Schedule resource.
        :param pulumi.Input[str] branch: The branch that the schedule should run on.
        :param pulumi.Input[str] cronline: The cronline that describes when the schedule should run. See[here](https://buildkite.com/docs/pipelines/scheduled-builds#schedule-intervals) for supported syntax.
        :param pulumi.Input[str] label: A label to describe the schedule.
        :param pulumi.Input[str] pipeline_id: The GraphQL ID of the pipeline that this schedule belongs to.
        :param pulumi.Input[str] commit: The commit that the schedule should run on.
        :param pulumi.Input[bool] enabled: Whether the schedule is enabled or not.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] env: The environment variables that scheduled builds should use.
        :param pulumi.Input[str] message: The message the builds show for builds created by this schedule.
        """
        pulumi.set(__self__, "branch", branch)
        pulumi.set(__self__, "cronline", cronline)
        pulumi.set(__self__, "label", label)
        pulumi.set(__self__, "pipeline_id", pipeline_id)
        if commit is not None:
            pulumi.set(__self__, "commit", commit)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if env is not None:
            pulumi.set(__self__, "env", env)
        if message is not None:
            pulumi.set(__self__, "message", message)

    @property
    @pulumi.getter
    def branch(self) -> pulumi.Input[str]:
        """
        The branch that the schedule should run on.
        """
        return pulumi.get(self, "branch")

    @branch.setter
    def branch(self, value: pulumi.Input[str]):
        pulumi.set(self, "branch", value)

    @property
    @pulumi.getter
    def cronline(self) -> pulumi.Input[str]:
        """
        The cronline that describes when the schedule should run. See[here](https://buildkite.com/docs/pipelines/scheduled-builds#schedule-intervals) for supported syntax.
        """
        return pulumi.get(self, "cronline")

    @cronline.setter
    def cronline(self, value: pulumi.Input[str]):
        pulumi.set(self, "cronline", value)

    @property
    @pulumi.getter
    def label(self) -> pulumi.Input[str]:
        """
        A label to describe the schedule.
        """
        return pulumi.get(self, "label")

    @label.setter
    def label(self, value: pulumi.Input[str]):
        pulumi.set(self, "label", value)

    @property
    @pulumi.getter(name="pipelineId")
    def pipeline_id(self) -> pulumi.Input[str]:
        """
        The GraphQL ID of the pipeline that this schedule belongs to.
        """
        return pulumi.get(self, "pipeline_id")

    @pipeline_id.setter
    def pipeline_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "pipeline_id", value)

    @property
    @pulumi.getter
    def commit(self) -> Optional[pulumi.Input[str]]:
        """
        The commit that the schedule should run on.
        """
        return pulumi.get(self, "commit")

    @commit.setter
    def commit(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "commit", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the schedule is enabled or not.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter
    def env(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        The environment variables that scheduled builds should use.
        """
        return pulumi.get(self, "env")

    @env.setter
    def env(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "env", value)

    @property
    @pulumi.getter
    def message(self) -> Optional[pulumi.Input[str]]:
        """
        The message the builds show for builds created by this schedule.
        """
        return pulumi.get(self, "message")

    @message.setter
    def message(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "message", value)


@pulumi.input_type
class _ScheduleState:
    def __init__(__self__, *,
                 branch: Optional[pulumi.Input[str]] = None,
                 commit: Optional[pulumi.Input[str]] = None,
                 cronline: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 env: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 label: Optional[pulumi.Input[str]] = None,
                 message: Optional[pulumi.Input[str]] = None,
                 pipeline_id: Optional[pulumi.Input[str]] = None,
                 uuid: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Schedule resources.
        :param pulumi.Input[str] branch: The branch that the schedule should run on.
        :param pulumi.Input[str] commit: The commit that the schedule should run on.
        :param pulumi.Input[str] cronline: The cronline that describes when the schedule should run. See[here](https://buildkite.com/docs/pipelines/scheduled-builds#schedule-intervals) for supported syntax.
        :param pulumi.Input[bool] enabled: Whether the schedule is enabled or not.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] env: The environment variables that scheduled builds should use.
        :param pulumi.Input[str] label: A label to describe the schedule.
        :param pulumi.Input[str] message: The message the builds show for builds created by this schedule.
        :param pulumi.Input[str] pipeline_id: The GraphQL ID of the pipeline that this schedule belongs to.
        :param pulumi.Input[str] uuid: The UUID of the schedule.
        """
        if branch is not None:
            pulumi.set(__self__, "branch", branch)
        if commit is not None:
            pulumi.set(__self__, "commit", commit)
        if cronline is not None:
            pulumi.set(__self__, "cronline", cronline)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if env is not None:
            pulumi.set(__self__, "env", env)
        if label is not None:
            pulumi.set(__self__, "label", label)
        if message is not None:
            pulumi.set(__self__, "message", message)
        if pipeline_id is not None:
            pulumi.set(__self__, "pipeline_id", pipeline_id)
        if uuid is not None:
            pulumi.set(__self__, "uuid", uuid)

    @property
    @pulumi.getter
    def branch(self) -> Optional[pulumi.Input[str]]:
        """
        The branch that the schedule should run on.
        """
        return pulumi.get(self, "branch")

    @branch.setter
    def branch(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "branch", value)

    @property
    @pulumi.getter
    def commit(self) -> Optional[pulumi.Input[str]]:
        """
        The commit that the schedule should run on.
        """
        return pulumi.get(self, "commit")

    @commit.setter
    def commit(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "commit", value)

    @property
    @pulumi.getter
    def cronline(self) -> Optional[pulumi.Input[str]]:
        """
        The cronline that describes when the schedule should run. See[here](https://buildkite.com/docs/pipelines/scheduled-builds#schedule-intervals) for supported syntax.
        """
        return pulumi.get(self, "cronline")

    @cronline.setter
    def cronline(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cronline", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the schedule is enabled or not.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter
    def env(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        The environment variables that scheduled builds should use.
        """
        return pulumi.get(self, "env")

    @env.setter
    def env(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "env", value)

    @property
    @pulumi.getter
    def label(self) -> Optional[pulumi.Input[str]]:
        """
        A label to describe the schedule.
        """
        return pulumi.get(self, "label")

    @label.setter
    def label(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "label", value)

    @property
    @pulumi.getter
    def message(self) -> Optional[pulumi.Input[str]]:
        """
        The message the builds show for builds created by this schedule.
        """
        return pulumi.get(self, "message")

    @message.setter
    def message(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "message", value)

    @property
    @pulumi.getter(name="pipelineId")
    def pipeline_id(self) -> Optional[pulumi.Input[str]]:
        """
        The GraphQL ID of the pipeline that this schedule belongs to.
        """
        return pulumi.get(self, "pipeline_id")

    @pipeline_id.setter
    def pipeline_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "pipeline_id", value)

    @property
    @pulumi.getter
    def uuid(self) -> Optional[pulumi.Input[str]]:
        """
        The UUID of the schedule.
        """
        return pulumi.get(self, "uuid")

    @uuid.setter
    def uuid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "uuid", value)


class Schedule(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 branch: Optional[pulumi.Input[str]] = None,
                 commit: Optional[pulumi.Input[str]] = None,
                 cronline: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 env: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 label: Optional[pulumi.Input[str]] = None,
                 message: Optional[pulumi.Input[str]] = None,
                 pipeline_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        A pipeline schedule is a schedule that triggers a pipeline to run at a specific time.

        You can find more information in the [documentation](https://buildkite.com/docs/pipelines/scheduled-builds).

        ## Example Usage

        ```python
        import pulumi
        import pulumiverse_buildkite as buildkite

        # create a pipeline
        pipeline = buildkite.pipeline.Pipeline("pipeline", repository="https://github.com/...")
        # schedule a build at midnight every day
        nightly = buildkite.pipeline.Schedule("nightly",
            pipeline_id=buildkite_pipeline["repo"]["id"],
            label="Nightly build",
            cronline="@midnight",
            branch=buildkite_pipeline["repo"]["default_branch"])
        ```

        ## Import

        import a pipeline schedule resource using the schedules GraphQL ID

        # 

         you can use this query to find the schedule:

         query getPipelineScheduleId {

         organization(slug: "ORGANIZATION_SLUG") {

         pipelines(first: 5, search: "PIPELINE_SEARCH_TERM") {

         edges{

         node{

         name

         schedules{

         edges{

         node{

         id

         }

         }

         }

         }

         }

         }

         }

         }

        ```sh
        $ pulumi import buildkite:Pipeline/schedule:Schedule test UGlwZWxpgm5Tf2hhZHVsZ35tLWRk4DdmN7c4LTA5M2ItNDM9YS0gMWE0LTAwZDUgYTAxYvRf49==
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] branch: The branch that the schedule should run on.
        :param pulumi.Input[str] commit: The commit that the schedule should run on.
        :param pulumi.Input[str] cronline: The cronline that describes when the schedule should run. See[here](https://buildkite.com/docs/pipelines/scheduled-builds#schedule-intervals) for supported syntax.
        :param pulumi.Input[bool] enabled: Whether the schedule is enabled or not.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] env: The environment variables that scheduled builds should use.
        :param pulumi.Input[str] label: A label to describe the schedule.
        :param pulumi.Input[str] message: The message the builds show for builds created by this schedule.
        :param pulumi.Input[str] pipeline_id: The GraphQL ID of the pipeline that this schedule belongs to.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ScheduleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        A pipeline schedule is a schedule that triggers a pipeline to run at a specific time.

        You can find more information in the [documentation](https://buildkite.com/docs/pipelines/scheduled-builds).

        ## Example Usage

        ```python
        import pulumi
        import pulumiverse_buildkite as buildkite

        # create a pipeline
        pipeline = buildkite.pipeline.Pipeline("pipeline", repository="https://github.com/...")
        # schedule a build at midnight every day
        nightly = buildkite.pipeline.Schedule("nightly",
            pipeline_id=buildkite_pipeline["repo"]["id"],
            label="Nightly build",
            cronline="@midnight",
            branch=buildkite_pipeline["repo"]["default_branch"])
        ```

        ## Import

        import a pipeline schedule resource using the schedules GraphQL ID

        # 

         you can use this query to find the schedule:

         query getPipelineScheduleId {

         organization(slug: "ORGANIZATION_SLUG") {

         pipelines(first: 5, search: "PIPELINE_SEARCH_TERM") {

         edges{

         node{

         name

         schedules{

         edges{

         node{

         id

         }

         }

         }

         }

         }

         }

         }

         }

        ```sh
        $ pulumi import buildkite:Pipeline/schedule:Schedule test UGlwZWxpgm5Tf2hhZHVsZ35tLWRk4DdmN7c4LTA5M2ItNDM9YS0gMWE0LTAwZDUgYTAxYvRf49==
        ```

        :param str resource_name: The name of the resource.
        :param ScheduleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ScheduleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 branch: Optional[pulumi.Input[str]] = None,
                 commit: Optional[pulumi.Input[str]] = None,
                 cronline: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 env: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 label: Optional[pulumi.Input[str]] = None,
                 message: Optional[pulumi.Input[str]] = None,
                 pipeline_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ScheduleArgs.__new__(ScheduleArgs)

            if branch is None and not opts.urn:
                raise TypeError("Missing required property 'branch'")
            __props__.__dict__["branch"] = branch
            __props__.__dict__["commit"] = commit
            if cronline is None and not opts.urn:
                raise TypeError("Missing required property 'cronline'")
            __props__.__dict__["cronline"] = cronline
            __props__.__dict__["enabled"] = enabled
            __props__.__dict__["env"] = env
            if label is None and not opts.urn:
                raise TypeError("Missing required property 'label'")
            __props__.__dict__["label"] = label
            __props__.__dict__["message"] = message
            if pipeline_id is None and not opts.urn:
                raise TypeError("Missing required property 'pipeline_id'")
            __props__.__dict__["pipeline_id"] = pipeline_id
            __props__.__dict__["uuid"] = None
        super(Schedule, __self__).__init__(
            'buildkite:Pipeline/schedule:Schedule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            branch: Optional[pulumi.Input[str]] = None,
            commit: Optional[pulumi.Input[str]] = None,
            cronline: Optional[pulumi.Input[str]] = None,
            enabled: Optional[pulumi.Input[bool]] = None,
            env: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            label: Optional[pulumi.Input[str]] = None,
            message: Optional[pulumi.Input[str]] = None,
            pipeline_id: Optional[pulumi.Input[str]] = None,
            uuid: Optional[pulumi.Input[str]] = None) -> 'Schedule':
        """
        Get an existing Schedule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] branch: The branch that the schedule should run on.
        :param pulumi.Input[str] commit: The commit that the schedule should run on.
        :param pulumi.Input[str] cronline: The cronline that describes when the schedule should run. See[here](https://buildkite.com/docs/pipelines/scheduled-builds#schedule-intervals) for supported syntax.
        :param pulumi.Input[bool] enabled: Whether the schedule is enabled or not.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] env: The environment variables that scheduled builds should use.
        :param pulumi.Input[str] label: A label to describe the schedule.
        :param pulumi.Input[str] message: The message the builds show for builds created by this schedule.
        :param pulumi.Input[str] pipeline_id: The GraphQL ID of the pipeline that this schedule belongs to.
        :param pulumi.Input[str] uuid: The UUID of the schedule.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ScheduleState.__new__(_ScheduleState)

        __props__.__dict__["branch"] = branch
        __props__.__dict__["commit"] = commit
        __props__.__dict__["cronline"] = cronline
        __props__.__dict__["enabled"] = enabled
        __props__.__dict__["env"] = env
        __props__.__dict__["label"] = label
        __props__.__dict__["message"] = message
        __props__.__dict__["pipeline_id"] = pipeline_id
        __props__.__dict__["uuid"] = uuid
        return Schedule(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def branch(self) -> pulumi.Output[str]:
        """
        The branch that the schedule should run on.
        """
        return pulumi.get(self, "branch")

    @property
    @pulumi.getter
    def commit(self) -> pulumi.Output[str]:
        """
        The commit that the schedule should run on.
        """
        return pulumi.get(self, "commit")

    @property
    @pulumi.getter
    def cronline(self) -> pulumi.Output[str]:
        """
        The cronline that describes when the schedule should run. See[here](https://buildkite.com/docs/pipelines/scheduled-builds#schedule-intervals) for supported syntax.
        """
        return pulumi.get(self, "cronline")

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Output[bool]:
        """
        Whether the schedule is enabled or not.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def env(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        The environment variables that scheduled builds should use.
        """
        return pulumi.get(self, "env")

    @property
    @pulumi.getter
    def label(self) -> pulumi.Output[str]:
        """
        A label to describe the schedule.
        """
        return pulumi.get(self, "label")

    @property
    @pulumi.getter
    def message(self) -> pulumi.Output[Optional[str]]:
        """
        The message the builds show for builds created by this schedule.
        """
        return pulumi.get(self, "message")

    @property
    @pulumi.getter(name="pipelineId")
    def pipeline_id(self) -> pulumi.Output[str]:
        """
        The GraphQL ID of the pipeline that this schedule belongs to.
        """
        return pulumi.get(self, "pipeline_id")

    @property
    @pulumi.getter
    def uuid(self) -> pulumi.Output[str]:
        """
        The UUID of the schedule.
        """
        return pulumi.get(self, "uuid")

